//
// motor.c : n݌v H8/36064 DC[^p֐
//

// @@Ӂ@
// VstoneА}CR{[hiVS-WRC003j́wVS-WRC003 eNjJ}jAxɂ́A
// P60[qiFTIOA0jPWMo͂pāACN1/M1RlN^DC[^]łƏĂ邪A
// ۂɂ́AFTIOA0PWMo͂̋@\LĂȂB
// (uH8/36064 O[vn[hEFA}jA w12. ^C}Z@12.2 o͒[qxvQ)
// ̂߁A{DC[^֘A֐Cuł́AP60[qiFTIOA0jACN1/M1RlN^舵ȂB


#include <machine.h>
#include "iodefine.h"
#include "motor.h"

void MotorInit(char port)
{
	/* PWM̃|[gE]̐ݒ */
	switch (port) {
		case 0:	// PWMFP61     ]FP32, P33
			IO.PCR3 |= 0x0C;	// P32, P33o͂ɐݒ
			IO.PDR3.BIT.B2 = 0;	// P32̏l0ɐݒ
			IO.PDR3.BIT.B3 = 0;	// P33̏l0ɐݒ
			IO.PCR6 |= 0x02;	// P61o͂ɐݒ
			break;
			
		case 1:	// PWMFP62 P63
			IO.PCR6 |= 0x0C;	// P62, P63o͂ɐݒ
			break;

		default:
			break;
	}

	/* ^C}Z0̐ݒ */
	set_imask_ccr(1);		// ^C}̐ݒ̑Oɂ͂
	TZ0.TCR.BIT.TPSC = 2;	// [010] /4ŃJEg

	switch (port) {
		case 0:	// PWMFP61     ]FP32, P33
			TZ.TPMR.BIT.PWMB0 = 1;	// FTIOB0PWMo͂ɐݒ
			TZ.TOER.BIT.EB0 = 0;	// FTIOB0̏o͂
			TZ0.GRB = 0;			// FTIOB0̃f[eB0
			break;
			
		case 1:	// PWMFP62 P63
			TZ.TPMR.BIT.PWMC0 = 1;	// FTIOC0PWMo͂ɐݒ
			TZ.TPMR.BIT.PWMD0 = 1;	// FTIOD0PWMo͂ɐݒ
			TZ0.GRC = 0;			// FTIOC0̃f[eB0
			TZ0.GRD = 0;			// FTIOD0̃f[eB0
			TZ.TOER.BIT.EC0 = 0;	// FTIOC0̏o͂
			TZ.TOER.BIT.ED0 = 0;	// FTIOD0̏o͂
			break;

		default:
			break;
	}
	
	TZ.TSTR.BIT.STR0 = 1;	// ^C}Z0N
	set_imask_ccr(0);		// ^C}ݒ肵I炱
}



void Motor(char port, char dir, unsigned int duty)
{
	switch (port) {
		case 0:	// PWMFP61     ]FP32, P33
			if (dir == 0) {				/* ] */
				IO.PDR3.BIT.B2 = 1;		// P32o͒l = 1
				IO.PDR3.BIT.B3 = 0;		// P33o͒l = 0
			} else {					/* t] */
				IO.PDR3.BIT.B2 = 0;		// P32o͒l = 0
				IO.PDR3.BIT.B3 = 1;		// P33o͒l = 1
			}

			TZ0.GRB = duty;				// GRBɃRyAlݒ
			break;
			
		case 1:	// PWMFP62 P63
			if (dir == 0) {				/* ] */
				TZ0.GRC = 0x0000;       // IN1(P62):0 , IN2(P63):PWM
				TZ0.GRD = duty;
			} else {					/* t] */
				TZ0.GRC = duty;         // IN1(P62):PWM , IN2(P63):0
				TZ0.GRD = 0x0000;
			}
			break;

		default:
			break;
	}
}